/*
 *
 *
	Programm zum Erstellen von Tex-Files fuer THEO
 *
 *
*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define DIM 12	/*Anzahl der Felder von str div 2*/
char* str[]={	"PROF__","Prof. Dr. Joachim Maruhn",
		"ADDR1__","Robert-Mayer-Stra\"se 8--10",
		"ADDR2__","Postfach 11 19 32",
		"ORT__","D--60054 Frankfurt am Main",
		"TEL__","Telefon (069) 798 23459",
		"DATUM__","14. Februar 2000",
		"TITEL1__","Theoretische Physik III",
		"TITEL2__","Elektrodynamik",
		"SEMKURZ__","WS",
		"SEM__","Wintersemester",
		"SEMDATE__","1999/2000",
		"UNTERSCHRIFT__","J.~Maruhn"
	};
FILE *file1,*file2;


int main ( int argc, char **argv )
{
	char name[35];
	char vorname[35];
	char datum[25];
	char anrede[10];
	char zeile[150];
	char* pstr;
	int c1,c2,page=1,readonly=0;	

	if(argc<=1){
	 printf("\n%s theo_schein_vorlage vorlage namens_liste\n",argv[0]);
	 printf("%s theo_schein_vorlage vorlage < namens_liste\n",argv[0]);
 	 printf("Diese Programm erstellt von einer Tex-Vorlage ");
	 printf("mit einer Namensliste und Vorlage Theo-Scheine auf STDOUT! ");
	 printf("Beschreibung unter http://www.th.physik.uni-frankfurt.de/~loizides\n");
	 exit(1);
	}
	if((file1=fopen(argv[1],"r"))==NULL)
	{
		printf("File %s not found!\n",argv[1]);
		exit(1);
	};

	if(argc>2) {
	  if((file2=fopen(argv[2],"r"))==NULL)
	  {
		printf("File %s not found!\n",argv[2]);
		exit(1);
	  };
	} else file2=stdin;

	fscanf(file2,"%s %s %s %s",anrede,vorname,name,datum);
	
	while(!feof(file2))
	{
#ifdef EINLESE_TEST
		printf("%s %s %s %s\n",anrede,vorname,name,datum);
		fscanf(file2,"%s %s %s %s",anrede,vorname,name,datum);
		continue;
#endif

		rewind(file1);
		c1=fgetc(file1);
		while(!feof(file1))
		{
			if(readonly)
			{
				if(c1=='{')
				{
					fscanf(file1,"%s",zeile);
					if(strcmp(zeile,"document}")==0)
					{
						readonly=0;
						c1=fgetc(file1);
						continue;
					}
				}
				c1=fgetc(file1);
			}
			if(readonly) continue;
			if(c1=='_'){
			  c2=fgetc(file1);
			  if(c2!='_'){
			    printf("%c%c",c2,c2);
			  } else {
		
				fscanf(file1,"%s",zeile);
				pstr=zeile;
				if(strcmp(zeile,"ANREDE__")==0) pstr=anrede;
				else if(strcmp(zeile,"VORNAME__")==0) pstr=vorname;
				else if(strcmp(zeile,"NAME__")==0) pstr=name;
				else if(strcmp(zeile,"GEB__")==0) pstr=datum;
				else {
					int i;
					for(i=0;i<2*DIM;i+=2)
					{
					  if(strcmp(zeile,str[i])==0){
					    pstr=str[i+1];
					    break;
					  }
					}
			  	}
				printf("%s",pstr);
				c1=fgetc(file1);
				if(c1!=' ') printf("%c",c1);
			  }
			} else printf("%c",c1);
		  	if(!feof(file1)) c1=fgetc(file1);
		}
		printf("\n");
		if(page%2==0) printf("\\newpage\n");
		fscanf(file2,"%s %s %s %s",anrede,vorname,name,datum);
		page++;
		readonly=1;
	}
	printf("\n\\end{document}\n");	
	fclose(file1);
	if(file2!=stdin) fclose(file2);
	return 1;
}
